Bug 1663033 - chrony is configured with non-FQDN, caused bogus DNS questions that might be abused
Summary: chrony is configured with non-FQDN, caused bogus DNS questions that might be ...
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: chrony
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Miroslav Lichvar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-01-02 19:16 UTC by Paul Wouters
Modified: 2019-05-28 23:37 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-05-28 23:37:02 UTC


Attachments (Terms of Use)

Description Paul Wouters 2019-01-02 19:16:59 UTC
Description of problem:

14:13:02.556110 IP 192.1.3.209.41872 > 192.1.3.254.domain: 46752+ A? 2.fedora.pool.ntp.org.testing.libreswan.org. (61)
14:13:02.556152 IP 192.1.3.209.41872 > 192.1.3.254.domain: 2741+ AAAA? 2.fedora.pool.ntp.org.testing.libreswan.org. (61)


Version-Release number of selected component (if applicable):
chrony-3.3-1.fc28.x86_64

How reproducible:
always. 

Steps to Reproduce:
1. configure a search domain in /etc/resolv.conf
2. tcpdump -nnnnnn port 53
3. restart chrony

If chrony really wants to support non-FQDN's, which might be a security risk, then the /etc/chrony.conf configuration line specifying 2.fedora.pool.ntp.org should gain a trailing dot.

If chrony does not want to support non-FQDN's, it should always append a trailing dot before sending the query to its DNS API

Comment 1 Miroslav Lichvar 2019-01-03 08:45:58 UTC
Interesting problem. Thanks for the report.

I think chrony users generally expect to be able to use relative domain names. If the support was removed, I suspect it would break a lot of things. So, I'd probably prefer the first proposed solution, although I'm not sure if that won't create confusion and perhaps even break some configuration tools that work with the chrony.conf file.

Comment 2 Petr Menšík 2019-01-28 10:18:47 UTC
Hi Paul,

are any options used in resolv.conf?
It has to try first FQDN, unless options ndots:4 is present in resolv.conf. Can you show full /etc/resolv.conf with just nameserver addresses replaced?

Is any local resolver present? It should always first try to resolve 2.fedora.pool.ntp.org. Unless it answers NXDOMAIN, it should never try appending search testing.libreswan.org as the first step. Reconfiguring it to absolute name would be workaround to libc resolver bug. If it does behave this way, it has to be fixed in glibc. Users should not have to use absolute names in every service they have.

My virtual machine tries 2.fedora.pool.ntp.org first. If attacker is able modify response to these names first, I think there is already security risk that usage of FQDN does not solve.

Comment 3 Ben Cotton 2019-05-02 19:57:45 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 4 Ben Cotton 2019-05-28 23:37:02 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.